#include "xtama_init.h"

void main(argc, argv)
int argc;
char **argv;
{
  int i , ii , j , k , nlength , l , x , y ;
  int screen , display_width, display_height , default_depth ;
  char display_name[10] , buffer[20] , colorbuffer[20] , *tmp = NULL ;
  unsigned char *tmpxbm ;
  XWindowAttributes root_attr ;
  XpmAttributes xpm_attr ;  
  XSetWindowAttributes xset_attr ;
  Pixmap back3 , back1 ;
  XGCValues gcval ;
  Font font ;
  Window root ;
  Bool isserver = False , Install = False ;

  int iro_data[12][3] = {
    { 0 , 0 , 255 } ,
    { 0 , 255 , 0 } ,
    { 255 , 255 , 0} ,
    { 255 , 0 , 0 } ,
    { 255 , 255 , 255},
    { 0 , 0 , 0 },
    {255 , 114 , 107 },
    {25 , 0 , 250},
    {238 , 238 , 0},
    {32 , 208 , 32},
    {125 , 0 , 150}
  } ;

  char *tama_iro[] = { 
    ".	c #FF726B",
    ".	c #1900FA",
    ".	c #eeee00",
    ".	c #20cc20",
    ".	c #7D0096",
  } ;

  XColor  colordef , colordef2 ;
  XVisualInfo vtmp , * vlist ;
  int vism ;

  char *number_xbm[] = { n0_bits , n1_bits , n2_bits , n3_bits , n4_bits ,
		         n5_bits , n6_bits , n7_bits , n8_bits , n9_bits ,
		         ren_bits , sa_bits } ;

  display_name[0] = (char)NULL ;
  buffer[0] = (char)NULL ;
  erase = ERASE ;
  mouse = net = False ;
    
  for ( i = 0 ; i < 3 ; i ++ )
    mous[i] = i + 1 ;

  i = 1 ;
  ii = 0 ;
  while( i < argc ){
    if ( !strcmp("-display",argv[i] )){
      strcpy( display_name , argv[++i] ) ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-rensa",argv[i] )){
      if ( ( erase = atoi(argv[++i])) < 2 )
	erase = 2 ;
      erase -- ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-install" , argv[i] )){
      Install = True ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-mouse",argv[i])){
      mouse = True;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-fall",argv[i] )){
      mous[FALL] = atoi( argv[++ i]) ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-lturn",argv[i] )){
      mous[LTURN] = atoi( argv[++ i]) ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-rturn",argv[i] )){
      mous[RTURN] = atoi( argv[++ i]) ;
      i ++ ;
      continue ;
    }
#ifdef NET
    if ( !strcmp("-host" ,argv[i] )){
      i ++ ;
      tmp = argv[i] ;
      isserver = False ;
      net = True ;
      i ++ ;
      continue ;
    }
    if ( !strcmp("-net",argv[i])){
      net = True ;
      isserver = True ;
      i ++ ;
      continue ;
    }
#endif
    usage(argv[0]) ;
  }
  
  dpy = XOpenDisplay(display_name);
  if (dpy == NULL) {
    fprintf(stderr, "PuzzleTama:  unable to open display '%s'\n",
            XDisplayName(display_name));
    return;
  }

#ifdef NET
  if ( net ){
    net_init( isserver , tmp ) ;
    while( ( fdc = dup( sockfd )) < 0 ) ;
    signal(SIGKILL,quit) ;
    signal(SIGTERM,quit) ;
  }
#endif
  
  srand48((int)time((time_t *)NULL));
  
  screen = DefaultScreen( dpy ) ;

  if ( Install ){
    vtmp.screen = screen ;
    vtmp.depth = DefaultDepth(dpy,screen) ;
    vtmp.class = PseudoColor ;
    
    vlist = XGetVisualInfo( dpy , VisualScreenMask|VisualDepthMask|
			   VisualClassMask , &vtmp , &vism ) ;
    
    if ( vism == 0 )
      printf("No matching visual \n") ;
    
    cmap = XCreateColormap(dpy, XDefaultRootWindow( dpy ),vlist[0].visual  , AllocNone);
  }
  else cmap = DefaultColormap( dpy , screen ) ;
  
  colordef.flags = DoRed | DoGreen | DoBlue;
  for (i = 0; i < 12; i++) {
    colordef.red =  iro_data[i][0] * 256 ;
    colordef.green = iro_data[i][1] * 256 ;
    colordef.blue = iro_data[i][2] * 256 ;
    
    if ( XAllocColor( dpy , cmap , &colordef ))
      iro[i] = colordef.pixel ;
    else fprintf(stderr,"Can't allocate Color \n" ) ;
  }

  screen = DefaultScreen(dpy);
  root = RootWindow(dpy, screen);

  display_width  = DisplayWidth(dpy, screen);
  display_height = DisplayHeight(dpy, screen);
  default_depth = DefaultDepth(dpy, screen);

  /* initiate windows */
  
  frame =  XCreateSimpleWindow(dpy, root, 0, 0, 
			       ( net ? 830 : 500 ) , 550,0, 1, 1);
  
  XSetWindowColormap( dpy , frame , cmap) ;

  back =  XCreateSimpleWindow(dpy, frame, 10, 35, 
			      320 , 480 ,0, 1, BlackPixel(dpy,0));
  
  vsback =  XCreateSimpleWindow(dpy, frame, 500, 35, 
			      320 , 480 ,0, iro[BLACK], iro[BLACK]);

  score =  XCreateSimpleWindow(dpy, frame, 340, 10, 
			       150 , 530,0, 1, WhitePixel(dpy , screen));
  
  sele =  XCreateSimpleWindow(dpy, frame , 0, 0, 
				200 , 100 , 0 , iro[WHITE] , iro[WHITE] ) ; 
  
  
  gcval.fill_style = FillTiled ;
  gcval.graphics_exposures = False ;
  
  gc = DefaultGC(dpy, DefaultScreen(dpy));
  gc2 = DefaultGC(dpy, DefaultScreen(dpy));

  XChangeGC( dpy , gc , GCGraphicsExposures , &gcval ) ;
  XChangeGC( dpy , gc2 , GCGraphicsExposures , &gcval ) ;
  gc3 = XCreateGC( dpy , frame , GCGraphicsExposures|GCFillStyle  , &gcval ) ;
  

  /* create pixmaps from data files */

  xset_attr.backing_store = Always ;
  XChangeWindowAttributes( dpy , frame , CWBackingStore , &xset_attr) ;
  
  XGetWindowAttributes(dpy, frame, &root_attr);

  xpm_attr.colormap = root_attr.colormap;
  xpm_attr.valuemask = XpmSize | XpmReturnPixels | XpmColormap;
  
  
  CreatePixmapFromData(dpy, frame, cmap , (char **)&back4_xpm,
                          &back_xpm, NULL ) ;
  
  CreatePixmapFromData(dpy, frame, cmap , (char **)&back2,
                          &back1, NULL ) ;
  
  for ( i = 0 ; i < 5 ; i ++ )
    {
      sprintf( colorbuffer , "%s" , tama_iro[ i ] ) ;
      
      ball_xpm_data[ 2 ] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap ,(char **)ball_xpm_data ,
			      &ball[i], &vmask[0] ) ;
      
      mini_ball_xpm_data[ 2 ] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap ,(char **)mini_ball_xpm_data ,
			      &ball[7+i], &vmask[1] ) ;
      
      
      grow1_xpm[2] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap ,(char **)grow1_xpm , 
			      &animation[i][0] ,
			      &animation_mask[0] ) ;
      
      grow2_xpm[2] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap ,(char **)grow2_xpm , 
			      &animation[i][1] ,
			      &animation_mask[1] ) ;
      
      grow3_xpm[2] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap ,(char **)grow3_xpm , 
			      &animation[i][2] ,
			      &animation_mask[2] ) ;
      
      grow4_xpm[2] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap , (char **)grow4_xpm , 
			      &animation[i][3] ,
			      &animation_mask[3] ) ;
      
      grow5_xpm[2] = colorbuffer ;
      CreatePixmapFromData(dpy, frame, cmap , (char **)grow5_xpm , 
			      &animation[i][4] ,
			      &animation_mask[4] ) ;
    }
  

  CreatePixmapFromData(dpy, back, cmap ,(char **)white_xpm,
			  &ball[5], NULL ) ;
  
  CreatePixmapFromData(dpy, back, cmap, (char **)black_xpm,
			  &ball[6], NULL );
  
  CreatePixmapFromData(dpy, frame, cmap, (char **)title_xpm,
			  &titl_xpm, &title_msk );
  
  CreatePixmapFromData(dpy, score, cmap, (char **)title2_xpm,
			  &titl2_xpm, &title2_msk );
  
  CreatePixmapFromData(dpy, score, cmap, (char **)tama_xpm,
			  &char_xpm, &char_msk );

  CreatePixmapFromData(dpy, frame, cmap, (char **)tama1_xpm,
			  &tama[0], &tama[1] );

  CreatePixmapFromData(dpy, frame, cmap, (char **)tama2_xpm,
			  &tama[2], &tama[3] );

  CreatePixmapFromData(dpy, score, cmap, (char **)back5_xpm,
			  &back3, NULL );

  CreatePixmapFromData(dpy, back, cmap, (char **)flush1_xpm,
			  &pdemo[0], &pdemo_mask[0] );

  CreatePixmapFromData(dpy, back, cmap, (char **)flush2_xpm,
			  &pdemo[1], &pdemo_mask[1] );

  CreatePixmapFromData(dpy, back, cmap, (char **)flush3_xpm,
			  &pdemo[2], &pdemo_mask[2] );
  
  CreatePixmapFromData(dpy, back, cmap, (char **)Bwhite_xpm,
			  &effect[0], &effect[1]);
  
  CreatePixmapFromData(dpy, back, cmap, (char **)Eblack_xpm,
			  &effect[2], &effect[3] );
 
  XSetWindowBackgroundPixmap(dpy, frame, back_xpm);
  XSetWindowBackgroundPixmap(dpy, back, back3);
  XSetWindowBackgroundPixmap(dpy, vsback, back3);
  XSetWindowBackgroundPixmap(dpy, score , back1);

  XStoreName( dpy , frame , "PuzzleTama") ;
  
  XSetForeground( dpy , gc , iro[BLUE] );

  sele_xpm[0] = XCreatePixmapFromBitmapData( dpy , sele , sl_attc_bits ,
					sl_attc_width , sl_attc_height ,
					    iro[YELLOW] , iro[BLACK] , default_depth ) ;

  sele_xpm[2] = XCreatePixmapFromBitmapData( dpy , sele , sl_scor_bits ,
					sl_scor_width , sl_scor_height ,
					    iro[BLUE] ,iro[WHITE]  , default_depth ) ;
  
  sele_xpm[1] = XCreatePixmapFromBitmapData( dpy , sele , sl_prac_bits ,
					sl_prac_width , sl_prac_height ,
					    iro[GREEN] ,iro[WHITE]  , default_depth ) ;

  sele_xpm[3] = XCreatePixmapFromBitmapData( dpy , sele , sl_quit_bits ,
					    sl_quit_width , sl_quit_height ,
					    iro[BLACK] , iro[WHITE] , default_depth ) ;
  
#ifdef NET

  sele_xpm[4] = XCreatePixmapFromBitmapData( dpy , sele , sl_taisen_bits ,
					sl_taisen_width , sl_taisen_height ,
					    iro[BLUE] , iro[YELLOW] , default_depth ) ;

  over[2] = XCreateBitmapFromData( dpy , sele , winner_bits ,
					winner_width , winner_height ) ;
  
  over[1] = XCreateBitmapFromData( dpy , sele , loser_bits ,
					loser_width , loser_height ) ;

#endif
 
  over[0] = XCreateBitmapFromData( dpy , sele , gameover_bits ,
				  gameover_width , gameover_height ) ;
  
  cursor_mask = XCreateBitmapFromData( dpy , frame , cursor_mask_bits ,
				      cursor_width , cursor_height ) ;
  cursor[0] = XCreateBitmapFromData( dpy , frame , cursor0_bits ,
				 cursor_width , cursor_height ) ;
  cursor[1] = XCreateBitmapFromData( dpy , frame , cursor1_bits ,
				 cursor_width , cursor_height ) ;
  cursor[2] = XCreateBitmapFromData( dpy , frame , cursor2_bits ,
				 cursor_width , cursor_height ) ;
  cursor[3] = XCreateBitmapFromData( dpy , frame , cursor3_bits ,
				 cursor_width , cursor_height ) ;
  cursor[4] = XCreateBitmapFromData( dpy , frame , cursor4_bits ,
				 cursor_width , cursor_height ) ;
  
  for ( i = 0 ; i < 4 ; i ++ ){
    colordef.blue = 255 * ( 255 - i * 85 ) ;
    colordef.red = 255 * 85 * i ;
    colordef.green = 0 ;
    colordef2.red = colordef2.green = colordef2.blue = 255 * ( 255 - i * 10 ) ;
    setcursor[i] = XCreatePixmapCursor( dpy , cursor[i] , cursor_mask , 
				       &colordef ,&colordef2 , 
				       cursor_x_hot , cursor_y_hot ) ;
  }
  colordef2.red = colordef2.green = colordef2.blue = 255 * 255 ;
  colordef.blue = 255 * 255 ;
  colordef.green = colordef.red = 0 ;
  setcursor[i] = XCreatePixmapCursor( dpy , cursor[i] , cursor_mask , 
				     &colordef ,&colordef2 , 
				     cursor_x_hot , cursor_y_hot ) ;
  
  nlength = number_width / Byte * number_height ; 
  tmpxbm = ( unsigned char * )malloc( nlength * 16 + 1 ) ;
  for ( ii = 0 ; ii < 12 ; ii ++ ){
    for ( y = 0 , l = 0 ; y < number_height ; y ++ ){
      for ( x = 0 ; x < number_width / Byte ; x ++ , l ++){
	for ( j = 0 ; j < Byte / 4 ; j ++ )
	  for ( k = 0 ; k < 4 ; k ++ ){
	    if ( number_xbm[ii][ y * number_width / Byte + x ] & 
		( 1 << ( Byte - j - 1 - Byte / 4 * k )))
	      tmpxbm[l*4+(3 - k)] |= 0xf << (( Byte/4 - j - 1 ) * 4 ) ;
	    else
	      tmpxbm[l*4+(3 - k)] &= 0xff^( 0xf << ( Byte/4 - j - 1 ) * 4 ) ;
	  }
      }
      for ( j = 1 ; j < 4 ; j ++ )
	for ( k = 0 ; k < 3 * 4 ; k ++ )
	  tmpxbm[( l - 3 + j * 3 ) * 4 + k]=tmpxbm[( l - 3 )*4+k] ;
      l += 3 * 3 ;
    }
    
    number[ii] = XCreateBitmapFromData( dpy , frame , tmpxbm ,
				       number_width * 4 , number_height * 4 ) ;
  }
  
  font=XLoadFont(dpy,"-*-*-bold-o-*-*-24-*-*-*-p-*-iso8859-1" );

  XSetFont( dpy , gc , font ) ;
  
  
  for ( i = 0 ; i < 4 ; i ++ )
    spa[i] = XCreatePixmap( dpy , back , 320 , 480 , default_depth ) ;
  
  tama_title() ;
  }
  
  void usage(char *name)
{
  printf("usage: %s [options]\n",name ) ;
  printf("  -display  display  ǥץ쥤ꤹ\n") ;
  printf("  -rensa    n      ĤǾä뤫\n");
  printf("                     (ϿΤϣĤλΤ)\n");
  printf("  -install           顼ޥåפ򥤥󥹥ȡ\n");
  printf("  -mouse             ޥ\n");
#ifdef NET
  printf("  -net               魯˵ưͤꤹ\n") ;
  printf("  -host     ۥ   魯˵ưͤ˵ưͤ\n");
  printf("                     ۥ̾ꤹ\n");
#endif
  printf("ޥΥܥѹ\n");
  printf("  -rturn ܥֹ  ǥեȤǤϣ\n") ;
  printf("  -fall  ܥֹ  ǥեȤǤϣ\n") ;
  printf("  -lturn ܥֹ  ǥեȤǤϣ\n") ;
 
  exit(0);
}

#ifdef NET

void quit ()
{
  
  char mess[10] ;
  if ( writen( sockfd , "qBreak\n" , 7 ) != strlen(mess) )
    err_sys("str_cli: writen error on socket") ;
  printf("close .\n");
  shutdown(sockfd,2) ;
  XCloseDisplay( dpy ) ;
  close(sockfd) ;
  exit(0);
}

#endif
