#include "xtama_rensa.h"
 
int seek ( int x , int y , int *rensa , int dir , int color )
{
  if ( map[x][y] != color || state[x][y] != 0 )
    return 0 ;

  state[x][y] |= dir ;
  (*rensa) ++ ;

  if ( !( state[x][y] & SEEK_LEFT ))
    {
      if ( x > 0 )
	seek( x - 1, y , rensa , SEEK_RIGHT , color ) ;
      state[x][y] |= SEEK_LEFT ;
    }
  
  if ( !( state[x][y] & SEEK_LOWER ))
    {
      if ( y < 11 )
	seek( x , y + 1 , rensa , SEEK_UPPER , color ) ;
      state[x][y] |= SEEK_LOWER ;
    }
  
  if ( !( state[x][y] & SEEK_RIGHT ))
    {
      if ( x < 7 )
	seek( x + 1 , y , rensa , SEEK_LEFT , color ) ;
      state[x][y] |= SEEK_RIGHT ;
    }
  
  if ( !( state[x][y] & SEEK_UPPER ))
    {
      if ( y > 0 )
	seek( x , y - 1 , rensa , SEEK_LOWER , color ) ;
      state[x][y] |= SEEK_UPPER ;
    }
  return * rensa ;
}


void tama_rensa( int rensa )
{
  int i , j , sw , count , sw2 = 0 ;

  struct Tmap{
    int x ;
    int y ;
    int color ;
    int state ;
  } tamamap[100] ;

#ifdef NET
  if ( net ) net_map( ) ; /* Υޥåפ */
#endif

  Dairensa ++ ; 

  for ( i = 0 ; i < 12 ; i ++ )
    for ( j = 0 ; j < 8 ; j ++ )
      miniball[j][i] = 0 ;
	
  sw2 = tama_grow( statemask )  ; /* 3İʾ夯äĤեå夷
                                     ͻ֤äƤ */
  
  tama_score( sw2 * rensa  ) ;  /* 򹹿 */

  for (i = 0 ; i < 12 ; i ++ )
    for ( j = 0 ; j < 8 ; j ++ )
      statemask[j][i] = 0 ;
  
  count = 0 ;

  for ( j = 0 ; j < 8 ; j ++ ) /* ͤ */
    {
      sw = 0 ;
      for ( i = 0 ; i < ( net ? 19 : 12 ) ; i ++ )
	{
	  if ( !map[j][i] && map[j][ i + 1 ] )
	    sw = True ;
	  if ( sw && map[j][i] )
	    {
	      statemask[j][i] = True ;
	      tamamap[count].x = j ;
	      tamamap[count].y = i * 4 ;
	      tamamap[count].color = map[j][i] ;
	      tamamap[count].state = True ;
	      count ++ ;
	      map[j][i] = 0 ;
	    }
	}
    }

  j = sw = count ;
  
  if ( sw2 || j ) timer(100000) ;

  while( sw )
    {
      sw = 0 ;
      for ( i = 0 ; i < count ; i ++ )
	if ( tamamap[i].state )
	  {
	    sw ++ ;
	    tamamap[i].state = tama_fall2( tamamap[i].x , &tamamap[i].y 
					  , tamamap[i].color ) ;
	  }
    }
  if ( sw2 || j ) 
    {
      /*timer(500000 - sw2 * 2000) ;*/
      tama_scan( rensa ) ;
    }
}

void tama_scan()
{
  int i , j , ii , jj , tmp , tmp_rensa ;

  tmp_rensa = 0 ;

  for ( i = 0 ; i < 12 ; i ++ )
    for ( j = 0 ; j < 8 ; j ++ )
      state[j][i] = statemask[j][i] = 0 ;
  
/* Ǥ  */
  
  for ( i = 0 ; i < 12 ; i ++ )
    for ( j = 0 ; j < 8 ; j ++ ) {
      if ( map[j][i] ) {
	tmp = 0 ;
	if ( map[j][i] < 6 && statemask[j][i] == 0 )
	  if ( seek( j , i , &tmp ,0 , map[j][i] ) > erase ) {
	    for ( ii = 0 ; ii < 12 ; ii ++ )
	      for ( jj = 0 ; jj < 8 ; jj ++ ) {
		if ( state[jj][ii] == 15 ) {
		  statemask[jj][ii] = True ;
		  rensa ++ ;
		  tmp_rensa ++ ;
		}
	      }
	  }
	for ( ii = 0 ; ii < 12 ; ii ++ )
	  for ( jj = 0 ; jj < 8 ; jj ++ )
	    state[jj][ii] =  0 ;
      }
    }
#ifdef NET  
  if ( net ) net_tama(tmp_rensa) ;
#endif
  tama_rensa(rensa) ;
}




