#include <stdio.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <X11/Xos.h> 
#include <X11/extensions/shape.h>
#include <unistd.h>
#include <signal.h>

#define LEFT 0
#define RIGHT 1
#define ERASE 2

#define BLUE 0 
#define GREEN 1
#define YELLOW 2
#define RED 3
#define WHITE 4
#define BLACK 5

#define MAXLINE 512

#define WRITE 1
#define READ 0

#define LTURN 0
#define FALL 1
#define RTURN 2

#include "xpm/back2.xpm"
#include "xpm/back4.xpm"
#include "xpm/back5.xpm"

#include "xpm/ball.xpm"
#include "xpm/mini-ball.xpm"

#include "xpm/title.xpm"
#include "xpm/title2.xpm"

#include "xpm/tama.xpm"
#include "xpm/tama1.xpm"
#include "xpm/tama2.xpm"

#include "xpm/grow1.xpm"
#include "xpm/grow2.xpm"
#include "xpm/grow3.xpm"
#include "xpm/grow4.xpm"
#include "xpm/grow5.xpm"

#include "xpm/white.xpm"
#include "xpm/black.xpm"
#include "xpm/Eblack.xpm"
#include "xpm/Bwhite.xpm"


#include "xpm/flush1.xpm"
#include "xpm/flush2.xpm"
#include "xpm/flush3.xpm"

#include "xpm/gameover.xbm"
#ifdef NET
#include "xpm/winner.xbm"
#include "xpm/loser.xbm"
#endif

#include "xpm/sl_attc"
#include "xpm/sl_scor"
#ifdef NET
#include "xpm/sl_taisen"
#endif
#include "xpm/sl_prac"
#include "xpm/sl_quit"

#include "xpm/cursor.xbm"
#include "xpm/number.xbm"
#define Byte 8

#include <sys/types.h>
#include <sys/socket.h>

void usage() , quit() , tama_title() , err_sys() , net_init() ;
int writen() ;

extern void CreatePixmapFromData( Display *dpy , Window win , Colormap cmap , char **xpmdata , Pixmap *pm1 , Pixmap *pm2 );

Pixmap back_xpm , vmask[2] , titl_xpm , title_msk , ball[12] , 
       titl2_xpm , title2_msk , animation[5][5] , animation_mask[5] , 
       effect[4] , spa[4] , tama[4] , over[3] , pdemo[3] , 
       pdemo_mask[3] , sele_xpm[5] ,char_xpm , char_msk ,
       cursor_mask , cursor[5] , number[12] ;


Window frame , back , score , title2 , char_win , sele , vsback ;

Cursor setcursor[5] ;

Display *dpy ;
GC gc , gc2 , gc3 ;

Colormap cmap ;
unsigned long iro[12] ; 

int map[8][19] , Score , tamakazu , rensa , Dairensa , level , 
    sockfd , erase  , fdc , mode , mous[3] , crr ;

Bool gameover , practice , net , mouse ;

fd_set readfd ;

