#include "xtama_main.h"

void tama_title()
{
  int i , value ;
  Bool res = 1 ;
  XEvent eve ;
  char tmp_char[4] ;
  KeySym keysym ;
  char mess[100] ;
  XSizeHints hint;
  
  XSelectInput( dpy , frame , KeyPressMask|ExposureMask|ButtonPressMask) ;

  XMapWindow( dpy , frame ) ;
  Setcursor( 0 ) ;
  
  if ( net )
    XMapSubwindows( dpy , frame ) ;
  
  mode = net * 4 ;
  
  while(1){

    hint.max_width  = hint.min_width  = net ? 830 : 500 ;
    hint.max_height = hint.min_height = 550 ;
    hint.flags = PMinSize | PMaxSize;
    XSetNormalHints(dpy, frame, &hint);

    XResizeWindow( dpy , frame , hint.max_width , hint.max_height ) ;

    XClearWindow( dpy , back  ) ;
    XClearWindow( dpy , score ) ;
    XClearArea( dpy , frame , 0 , 0 , 0 , 0 , True ) ;
    
    timer( 10000 ) ;

    XSetWindowBackgroundPixmap( dpy , sele , sele_xpm[mode] ) ;
    if ( net ) XMoveWindow( dpy , sele ,60 , 220 ) ;
    else XMoveWindow( dpy , sele ,150 , 300 ) ;
    
    XClearWindow( dpy , sele ) ;

    XMapWindow( dpy , sele ) ;
    
    XSync( dpy , 0 ) ;
    
    res = 1 ;
    
    while( res ){
      if( XEventsQueued( dpy, QueuedAfterFlush ) ){
	XNextEvent( dpy , &eve ) ;
	if ( eve.type == Expose && !net )
	  tama_show_title() ;
	else {
	  if ( eve.type == KeyPress ){
	    XLookupString( (XKeyEvent *)&eve , tmp_char , 4 , &keysym , NULL ) ;
	    value = keysym ;
	  }
	  else
	    value = button( eve.xbutton.button ) ;
	  switch ( value ) {
	  case XK_q:
#ifdef NET
	    strcpy( mess , "cQuit\n\0") ;
	    if ( net ) if ( writen( sockfd , mess , strlen(mess) ) != strlen(mess) ) ;
#endif
	    XCloseDisplay( dpy ) ;
	    exit(0);
	    break ;
	  case FALL:
	    if ( !mouse )
	      break ;
	  case XK_space:
	    res = 0 ;
	    break ;
	  case LTURN:
	    if ( !mouse )
	      break ;
	  case XK_Left:
	    if ( !net )
	      for ( i = 150 ; i < 500 ; i += 40 ){
		XMoveWindow( dpy , sele , i  , 300 ) ;
		
		XSync( dpy , 1 ) ;
		timer( 10000 ) ;
	      }
	    mode -- ;
	    if ( mode < 3 && net ) mode = 4 ; 
	    if ( mode < 0 && !net ) mode = 3 ;
	    
	    XSetWindowBackgroundPixmap( dpy , sele , 
				       sele_xpm[ mode ] ) ;
	    XClearWindow( dpy , sele ) ;
	    XSync( dpy , 1 ) ;
	    
	    if ( !net )
	      for ( i = -210 ; i < 160 ; i += 40 ){
		XMoveWindow( dpy , sele , i  , 300 ) ;
		XSync( dpy , 1 ) ;
		timer( 10000 ) ;
	      }
	    break ;
	  case RTURN:
	    if ( !mouse )
	      break ;
	  case XK_Right:
	    if ( !net )
	      for ( i = 150 ; i > -240 ; i -= 40 ){
		XMoveWindow( dpy , sele , i  , 300 ) ;
		XSync( dpy , 1 ) ;
		timer( 10000 ) ;
	      }
	    mode ++ ;
	    if ( mode > 4 && net ) mode = 3 ;
	    if ( mode > 3 && !net ) mode = 0 ;
	    
	    XSetWindowBackgroundPixmap( dpy , sele , sele_xpm[ mode ] ) ;
	    XClearWindow( dpy , sele ) ;
	    XSync( dpy , 1 );

	    if ( !net )
	      for ( i = 510 ; i > 140 ; i -= 40 ){
		XMoveWindow( dpy , sele , i  , 300 ) ;
		XSync( dpy , 1 ) ;
		timer( 10000 ) ;
	      }
	  default:
	    break ;
	  }
	}
      }
      timer( 100000 ) ;
    }
    
    if ( mode == 0 || mode == 1 || mode == 4 ){
      XUnmapWindow( dpy , sele ) ;
      XClearWindow( dpy , frame ) ;
      if ( !net ) {
	XMapWindow(dpy ,back);
	XMapWindow(dpy, score);
	XSync( dpy , 1 ) ;
      }
      practice = ( mode == 1 ) ; /* ⡼*/
      tama_main() ;
      
      if ( !net ) {
	XUnmapWindow( dpy , back ) ;
	XUnmapWindow( dpy , score ) ;
	XSync( dpy , 1 ) ;
      }
      
      if ( mode == 0 && erase == ERASE ) scoredemo() ;
      Score = 0 ;
      Setcursor(0) ;
    }
    
    if ( mode == 2 ){
      Setcursor( 4 ) ;
      XUnmapWindow( dpy , sele ) ;
      XClearWindow( dpy , frame ) ;
      scoredemo() ;
      Setcursor( 0 ) ;
    };
    
    if ( mode == 3 ){
#ifdef NET
      if ( net ){
	strcpy( mess , "cQuit\n\0") ;
	if ( writen( sockfd , mess , strlen(mess) ) != strlen(mess) ) ;
      }
#endif
      XCloseDisplay( dpy ) ;
      exit(0);
    }
    XSync( dpy , 1 ) ;
  }
}

void tama_show_title()
{
  int values ;
  XGCValues gcval ;
  
  values =  GCTileStipXOrigin|GCTileStipYOrigin|
    GCClipXOrigin|GCClipYOrigin| GCTile | GCClipMask |GCFillStyle ;
  gcval.fill_style = FillTiled ;
  gcval.ts_x_origin = gcval.clip_x_origin = 122 ;
  gcval.ts_y_origin = gcval.clip_y_origin = 120 ;
  gcval.tile = titl_xpm ;
  gcval.clip_mask = title_msk ;
  XChangeGC( dpy , gc3 , values , &gcval) ;
  XFillRectangle( dpy , frame , gc3 , 122 , 120 , 256 , 90 ) ;
  XSync( dpy , 0 ) ;
}

void tama_main()
{
  int j ,i , ii , tx1 , tx2 , tmp_score = 0 , task = 0 , max ;
  int ty1 , ty2 , value ;
  char buffer[4] , mess[MAX] ;
  KeySym keysym ;
  XEvent eve ;
  unsigned long values ;
  XGCValues gcval ;
  int sw , speed , color1 , color2 , color1_b , color2_b ;
  struct timeval  time , tmp_time ;
  Bool res ;
  Window win ;

  values = GCTile | GCFillStyle | GCClipMask  ;
  gcval.tile = animation[1][4] ;
  gcval.clip_mask = animation_mask[4] ;
  gcval.fill_style = FillTiled ;
  XChangeGC( dpy , gc3 , values , &gcval ) ;
  
  for ( i = 0 ; i < 8 ; i ++ )
    for ( ii = 0 ; ii < 19 ; ii ++ )
      map[i][ii] = 0 ;
    
  XSelectInput( dpy , frame , KeyPressMask|ExposureMask|ButtonPressMask ) ;
  XSelectInput( dpy , score , ExposureMask ) ;
  
  level = 0 ;
  if ( !net ){
    text_etc();
    level_disp(level) ;
  }
  else
    text_etc2();
  
  XSync( dpy , True );
  
  sw = 0 ;

  max = getspeed ( level ) ;

  select_tama( &color1 , &color2  ) ;

  if ( !net ){
    gettimeofday( &time , NULL ) ;  
    time.tv_sec += 30 ;
    Score = tmp_score = 0 ;
    task = tamakazu = 50 ;
    tama_timer( time.tv_sec ) ;
  }
  
#ifdef NET
  if ( net ) {
    strcpy( mess , "cStart game!\n\0") ;
    if ( writen( sockfd , mess , strlen(mess) ) != strlen(mess) )
      err_sys("str_cli: writen error on socket") ;
    sprintf(mess,"e%c\n", '!' + erase );
    if ( writen( sockfd , mess , strlen(mess) ) != strlen(mess) )
      err_sys("str_cli: writen error on socket") ;
    tamakazu = 0 ;
    res = False ;
    do {
      strcpy( mess , "Start game!") ;
      res = net_getmessage(mess) ;
      if (!strcmp("Quit" , mess )) {
	return ;
      }
    } while( !res ) ;
    XClearWindow( dpy , vsback ) ;
  }
#endif

  gameover = False ;
  
  while(True)
    {
      tx1 = tx2  = 3 ;
      select_tama( &color1_b , &color2_b  ) ;
      
      MoveWindow( color1_b , color2_b , 1 , 20 , 1, 24 ,True ,
		 1 , 20 , 1, 24 , score ) ;

      
      ty1 = 48;
      ty2 = 52 ;
      
      MoveWindow( color1 , color2 , tx1  ,ty1 , tx2 , ty2 , False , 
		 0 , 0 , 0, 0 , back );

      XSync( dpy , 0 ) ;

      while ( tama_fall( &tx1, &ty1 , &tx2 , &ty2 , sw , color1 , color2))
	{
#ifdef NET
	  if ( net ) {
	    tmp_time.tv_sec = 0 ;
	    tmp_time.tv_usec = 0 ;
	    FD_ZERO( &readfd ) ;
	    FD_SET( fdc , &readfd ) ;
	    if ( select( fdc + 1 , &readfd , (fd_set *) 0 , 
			(fd_set * )0 ,&tmp_time )){
	      strcpy( mess , "Game over.");
	      if ( net_getmessage(mess)) {
		values = GCStipple | GCClipMask | GCTileStipXOrigin|
		  GCTileStipYOrigin | GCClipXOrigin|
		    GCClipYOrigin |GCFillStyle | GCForeground;
		gcval.foreground = iro[RED] ;
		gcval.stipple = over[2] ;
		gcval.clip_mask = over[2] ;
		gcval.fill_style = FillStippled ;
		gcval.ts_y_origin = gcval.clip_y_origin = 230 ;  
		gcval.ts_x_origin = gcval.clip_x_origin = 75  ;
		XChangeGC( dpy , gc3 , values , &gcval) ;
		XFillRectangle( dpy , back , gc3 ,  75  , 230 , 156 , 35  ) ;
		Setcursor(4) ;
		XSync( dpy , 0 ) ;
		gcval.fill_style = FillTiled ;
		XChangeGC( dpy , gc3 ,GCFillStyle,&gcval ) ;
		gameover = True ;
		goto Label2 ;
	      }
	    }
	  }
#endif
	  for ( speed = 0 ; speed < max  && !sw ; speed ++ )
	    {
	      if( XEventsQueued( dpy, QueuedAfterFlush ) == 0 ) ;
	      else 
		{
		  XNextEvent( dpy , &eve ) ;
		  if ( eve.type == KeyPress || (eve.type == ButtonPress && mouse)){
		    if ( eve.type == KeyPress ){
		      XLookupString( (XKeyEvent *)&eve , buffer , 4 , &keysym ,
				    NULL ) ;
		      value = keysym ;
		    }
		    else 
		      value = button( eve.xbutton.button ) ;
		    switch( value ) {
		    case XK_q:
		      goto Label ;
		      break ;
		    case XK_s:
		      {
			int i , j ; 
			for ( i = 0 ; i < 15 ; i ++ )
			  {
			    for ( j = 0 ; j < 8 ; j ++ )
			      printf("(%2d)",map[j][14-i] ) ;
			    putchar('\n') ;
			  }
		      }
		      break ;
		      
		    case XK_space:
		    case FALL:
		      sw = 1 ;
		      speed += 100 ;
		      break ;
		    case XK_Right:
		      tama_moveside( &tx1 , &ty1 ,
				    &tx2 , &ty2 , RIGHT , color1 , color2);
		      break ;
		    case XK_Left:
		      tama_moveside(  &tx1 , &ty1 ,
				    &tx2 , &ty2 , LEFT , color1 , color2);
		      break ;
		    case XK_Up:
		    case LTURN:
		      tama_roll( &tx1 , &ty1 , &tx2 , &ty2 , LEFT ,
				color1 , color2 ) ;
		      break ;
		    case XK_Down:
		    case RTURN:
		      tama_roll( &tx1 , &ty1 , &tx2 , &ty2 , RIGHT , 
				color1 , color2 ) ;
		      break ;
		    case XK_p:
		      XClearWindow( dpy , back ) ;
		      res = False ;
		      gettimeofday( &tmp_time , NULL ) ;
		      time.tv_sec =  time.tv_sec  - tmp_time.tv_sec ;
		      
#ifdef NET
		      strcpy( mess , "cPause.\n\0") ;
		      if ( net ) 
			if ( writen( sockfd , mess , strlen(mess) ) 
			    != strlen(mess) )
			  err_sys("str_cli: writen error on socket") ;
#endif			
		      do{
			if(XEventsQueued( dpy, QueuedAfterFlush ) ){
			  XNextEvent( dpy , &eve ) ;
			  if ( eve.type == KeyPress ){
			    XLookupString( (XKeyEvent *)&eve , buffer , 4 , &keysym , NULL ) ;
			    if ( keysym == XK_p)
			      res = True ;
			  }
			}
		      }while(!res) ;
#ifdef NET
		      strcpy( mess , "cStart.\n\0") ;
		      if ( net ) 
			if ( writen( sockfd , mess , strlen(mess) ) 
			    != strlen(mess) )
			  err_sys("str_cli: writen error on socket") ;
#endif	
		      XSync( dpy , 0 );
		      gettimeofday( &tmp_time , NULL ) ;
		      time.tv_sec =  tmp_time.tv_sec  + time.tv_sec ;
		      for ( i = 0 ; i < 12 ; i += 2 )
			for ( j = 0 ; j < 8 ; j ++ )
			  MoveWindow( map[j][i] - 1 , map[j][i+1] - 1 
				     , j , i * 4 , j , i * 4 + 4 , False , 
				     0 , 0 , 0 , 0 , back ) ;
		    }
		  }
		  if ( eve.type == Expose )
		    {
		      if ( !net ){
			text_etc();
			tama_timer( time.tv_sec ) ;
			tama_score( 0 ) ;
			MoveWindow( color2_b , color1_b , 1 , 20 , 1, 24 ,False , 
				   0 , 0 , 0, 0 , score ) ;
		      }
		      else
			text_etc2() ;
		      XClearWindow( dpy , back ) ;
		      for ( i = 0 ; i < 12 ; i += 2 )
			for ( j = 0 ; j < 8 ; j ++ )
			  MoveWindow( map[j][i] - 1 , map[j][i+1] - 1 , 
				     j , i * 4 , j , i * 4 + 4 , False ,
				     0 , 0 , 0 , 0 , back ) ;
		    }
		}
	      if ( mouse ){
		XQueryPointer( dpy , back , &win , &win ,
			      &i ,&i , &j , &i , ( unsigned int *) &i ) ;
		i = j / 40 ;
		if ( tx1 < i )
		  tama_moveside( &tx1 , &ty1 ,
				&tx2 , &ty2 , RIGHT , color1 , color2);
		if ( tx1 > i )
		  tama_moveside( &tx1 , &ty1 ,
				&tx2 , &ty2 , LEFT , color1 , color2);
		
	      } 
	      timer(5000) ;
	    }
	}
      
      if ( gameover )
	goto Label ;
      
      sw = 0 ;
      
      tama_set( tx1 , ty1 ,tx2 ,ty2 , color1 , color2 ) ;

      rensa = Dairensa = 0 ;

      if ( color2 == 5 || color2 == 6 ){
	tama_war(tx1 , ty1 ,tx2 ,ty2 , color1 , color2);
	if ( !net ) tamakazu -= rensa ;
      }
      else{ 
	tama_scan() ;
	if ( !net ) tamakazu -= rensa * ( Dairensa - 1 ) ;
      }

      color1 = color1_b ;
      color2 = color2_b ;

      if ( !net ){
	if ( ( tama_timer( time.tv_sec , tmp_score ))){
	  tama_pulas( tamakazu > 0 ? tamakazu : 0 ) ;
	  gettimeofday( &time , NULL ) ;
	  time.tv_sec += 30 + practice * 10 ;
	  tamakazu = ++ task ;
	  tama_timer( time.tv_sec ) ;
	  
	  max = getspeed( level ) ;
	  level ++ ;
	  level_disp( level ) ;
	}
	
	tmp_score = Score ;
      }
      else 
	if ( tamakazu > 0 ) {
	  tamakazu -= tama_pulas( tamakazu ) ;
	  /*if ( tamakazu > 16 ) {
	    tamakazu -= tama_pulas(16) ;
	  }
	  else {
	    tamakazu -= tama_pulas( tamakazu ) ;
	  }*/
	}
      Setcursor(-1) ;
    }
  
  Label :
#ifdef NET
    if ( net ) {
      strcpy( mess , "cGame over.\n\0") ;
      if ( writen( sockfd , mess , strlen(mess) ) != strlen(mess) )
	err_sys("str_cli: writen error on socket") ;
    }
#endif
  Label2 :
    /*here*/;
  
  XSync( dpy , 1 ) ;
  while( XEventsQueued( dpy, QueuedAfterFlush ) == 0 ) 
    timer(10000) ;
  
  return ;
  
}

void timer( int interval ) /* the timer function */
{
  struct  timeval  new_time ;
  
  new_time.tv_sec = 0 ;
  new_time.tv_usec = interval ;
  select( 0 , (fd_set *) 0, (fd_set *) 0, (fd_set *) 0, &new_time ) ;
  return ;

}


void select_tama(int *r1 , int *r2 ) 
{
  int i ;
  int * rnd[2] = { r1 , r2 } ;

  if ( !(lrand48() % 8) )
    {
      if ( !practice ){
	*rnd[0] = *rnd[1] = lrand48() % 2 + 5 ;
	if ( *rnd[0] == 6 )
	  *rnd[0] = lrand48() % 5 ;
      }
      else *rnd[0] = *rnd[1] = 5 ;
    }
  
  else
    for ( i = 0 ; i < 2 ; i ++ )
      {
	if ( lrand48() % 4 )
	  *rnd[i] = lrand48() % 5 ;
	else 
	  *rnd[i] = lrand48() % 5 + 7 ;
      }
}

int getspeed( int level )
{
  int tmpspeed ;
  if ( practice )
    tmpspeed = 15 - ( level * 0.3 ) ;
  else
    tmpspeed = 9 - ( level * 0.24 ) ;
  
  if ( tmpspeed < 3 ) {
    if ( level > 34 )
      tmpspeed =2 ;
    else
      tmpspeed = 3 ;
  }
  return tmpspeed ;
}

void text_etc()
{
  int values ;
  XGCValues gcval ;
  
  XSetForeground( dpy , gc , iro[BLUE] ) ;
  XClearWindow( dpy , score ) ;
  XDrawString( dpy , score , gc ,  8 ,  90 ,"Level" , 5 ) ;
  XDrawString( dpy , score , gc , 10 , 116 ,"Score" , 5 ); 
  XDrawString( dpy , score , gc , 10 , 190 ,"NEXT" , 4 ) ;
  XDrawString( dpy , score , gc , 10 , 315 ,"Timer" , 5 );
  XDrawString( dpy , score , gc , 10 , 395 ,"Task" , 4 ) ;
  
  values =  GCTileStipXOrigin|GCTileStipYOrigin|
    GCClipXOrigin|GCClipYOrigin| GCTile | GCClipMask | GCFillStyle ;
  gcval.fill_style = FillTiled ;
  gcval.ts_x_origin = gcval.clip_x_origin = 2 ;
  gcval.ts_y_origin = gcval.clip_y_origin = 10 ;
  gcval.tile = titl2_xpm ;
  gcval.clip_mask = title2_msk ;
  XChangeGC( dpy , gc3 , values , &gcval) ;
  XFillRectangle( dpy , score , gc3 , 2 , 10 , 147 , 49 ) ;
  
  gcval.ts_x_origin = gcval.clip_x_origin = 30 ;
  gcval.ts_y_origin = gcval.clip_y_origin = 430 ;
  gcval.tile = char_xpm ;
  gcval.clip_mask = char_msk ;
  XChangeGC( dpy , gc3 , values , &gcval) ;
  XFillRectangle( dpy , score , gc3 , 30 , 430 , 89 , 93 ) ;
  XSync( dpy , 0 ) ;
}

void text_etc2()
{
  XSetForeground( dpy , gc , iro[BLUE] ) ;
  XDrawString( dpy , score , gc , 10 , 116 ,"Score" , 5 ); 
  XDrawString( dpy , score , gc , 10 , 190 ,"NEXT" , 4 ) ;
}


int button( int bnum )
{
  int i ;
  for ( i = 0 ; i < 3 ; i ++ )
    if ( mous[i] == bnum )
      return i ;

  return 0 ;
}
