#include "xtama_score.h"
 
void tama_score( int score_hint )
{
  char buf[10] ;
  
  Score += score_hint ;
  
  sprintf( buf ,"%7d",Score );
  
  XClearArea( dpy , score , 0 , 126 , 150 , 40 , 0 ) ;
  
  XSetForeground( dpy , gc , iro[YELLOW]  );

  XDrawString( dpy , score , gc , 40 , 156 , buf , 7 ) ; 

}

void level_disp( int level )
{
  char buf[10] ;
  
  sprintf( buf ,"%7d",level );
  
  XClearArea( dpy , score , 80 , 70 , 70 , 40 , 0 ) ;

  XSetForeground( dpy , gc , iro[YELLOW]  );

  XDrawString( dpy , score , gc , 56 , 90 , buf , 7 ) ; 

}

void tama_tama( int left_tama )
{
  char buf[10] ;
  
  if ( left_tama < 0 ) left_tama = 0 ;

  sprintf( buf ,"%7d",left_tama ) ;
  
  XClearArea( dpy , score , 0 , 395 , 150 , 40 , 0 ) ;
  
  XSetForeground( dpy , gc , iro[YELLOW] );
  
  XDrawString( dpy , score , gc , 40 , 415 , buf , 7 ) ; 
}
  
Bool tama_timer( long time , int tmp_score )
{
  struct  timeval  now_time ;
  
  gettimeofday( &now_time , NULL );
  
  tama_tama( tamakazu ) ;
  
  if ( now_time.tv_sec > time  )  return True ;
  else{
    tama_drawtime( time - now_time.tv_sec );
    return False ;
  }
  
}

void tama_drawtime( int late )
{
  int i ;
  XGCValues values ;

  values.line_width = 3 ;

  XSetForeground( dpy , gc , iro[GREEN] );

  XChangeGC( dpy , gc , GCLineWidth , &values ) ;
  
  XClearArea( dpy , score , 0 , 328 , 155 , 20 , 0 ) ;
  
  XDrawLine( dpy , score , gc , 9 , 350 , 142 , 350 ) ;
  
  for ( i = 0 ; i < 11 ; i ++ )
    XDrawLine( dpy , score , gc , 13 * i + 10 , 340 , 13 * i + 10 , 350 ) ;

  XSetForeground( dpy , gc , iro[BLUE] );

  late /= 3 ;

  for ( i = 0 ; i < late ; i ++ )
    XFillRectangle( dpy , score , gc , 13 * i + 12 , 336 , 10 , 12 ) ;

}


void scoredemo()
{  
  GC  gc2;
  Font  font1, font2;  /* եȹ¤Τ */
  XEvent  eve;
  int  i, j , ii , k , tmp ;

#define BUFF_LENGTH 21
#define RANK_NAME_LENGTH 20
  char buf[BUFF_LENGTH] ;
  char writing_fname[512] ;

  struct sco {
    int uid ;
    int score ;
    int level ;
  } lank[16] ;
  
  static  char  *message[] = {
    "Score Ranking  Best  15"," Name                  Score   Level"
  };
  
  struct passwd *pass;
 
  FILE *file ;

#ifdef FILELOCK
  int msg_flag ;
#endif  

  if ( !getpwuid(getuid()) ){
    printf("Can't get User infomation \n");
    return ;
  }

#ifndef SFILE
#define SFILE ".tama_score"
#endif

  strcpy( writing_fname , SFILE ) ;

#ifdef FILELOCK
  strcat( writing_fname , "-writing" ) ;
  k = rename( SFILE , writing_fname ) ;
  msg_flag = 0 ;
  while( k < 0 ){
       k = rename( SFILE , writing_fname ) ;
       if( msg_flag == 0 ) {
	    printf("¾οͤϿʤΤ....\n") ;
	    msg_flag = 1 ;
       }
  }
  if( msg_flag != 0 ) printf("......OK\n") ;
#endif
  if ( (file = fopen( writing_fname ,"r") ) == NULL )
    {
      if ( (file = fopen( writing_fname , "a" )) == NULL ) {
	printf("Can't create file %s\n", writing_fname ) ;
	return ;
      }
      for ( i = 0 ; i < 15 ; i ++ )
	fprintf( file ,"%d %d %d \n", 0 ,100 * ( 15 - i ) , 14 - i) ;
      fclose( file ) ;
      file = fopen( writing_fname ,"r" ) ;
   }
  
  for ( i = 0 ; i < 15 ; i ++ )
    fscanf( file ,"%d %d %d",&lank[i].uid,&lank[i].score,&lank[i].level) ;

  
  fclose(file);

  i = 0 ;
  while ( lank[i].score >= Score  && i < 15 )
    i ++ ;
  
  if ( i < 15 )
    {
      i = 0 ;
      while ( lank[i].uid != getuid() && i < 15 )
	i ++ ;
      
      if ( i == 15 )
	{
	  lank[14].uid   = getuid() ;
	  lank[14].score = Score ;
	  lank[14].level = level ;
	}
      else
	    if ( lank[i].score < Score )
	      {
		/*lank[i].uid   = getuid() ; */
		lank[i].score = Score ;
		lank[i].level = level ;
	      }
      
      for ( i = 1 ; i < 15 ; i ++ )
	for ( j = i ; j < 15 ; j ++ )
	  {
	    if ( lank[15-j].score > lank[14 -j].score )
	      { 
		tmp = lank[15-j].uid  ;  
		lank[15-j].uid   = lank[14 -j].uid ;
		lank[14 -j].uid  = tmp ;
		
		    tmp = lank[15-j].score  ;
		lank[15-j].score   = lank[14 -j].score ;
		lank[14 -j].score  = tmp ;
		
		tmp = lank[15-j].level  ;
		lank[15-j].level   = lank[14 -j].level ;
		lank[14 -j].level  = tmp ;
	      }
	  }
      
      file = fopen( writing_fname ,"w");
      
      for ( i = 0 ; i < 15 ; i ++ )
	fprintf( file ,"%d %d %d \n",lank[i].uid,lank[i].score,lank[i].level) ;
      fclose( file ) ;
    }
#ifdef FILELOCK
  rename( writing_fname , SFILE ) ;
#endif FILELOCK
  
  font1= XLoadFont( dpy, "9x15bold" );
  /*font2= XLoadFont( dpy, "-adobe-times-bold-i-normal--*-240-*-*-p-*-*" );*/
  font2= XLoadFont( dpy, "-*-*-bold-o-*-*-24-*-*-*-p-*-iso8859-1" );

  gc2 = XCreateGC( dpy, frame, (unsigned long)NULL, NULL );
  
  i = 240 ;
  
  XSetForeground( dpy , gc2 , iro[BLUE] );

  XSetFont( dpy, gc2, font2 ); /* եȤ */
  XFlush( dpy );
  XDrawString( dpy, frame, gc2, 160, 270-i,
		   message[0], strlen(message[0]) );
  XSetFont( dpy, gc2, font1 ); /* եȤ */
  XFlush( dpy );
  XDrawString( dpy, frame, gc2, 100, 300-i,
		   message[1], strlen(message[1]) );
  for ( ii = 0 ; ii < 15 ; ii ++ )
    {
      for( k=0 ; k<BUFF_LENGTH ; k++ ) buf[k]=0 ;
      if (!(pass = getpwuid(lank[ii].uid)))
	sprintf(buf,"Anonymous");      
      else {
	strncpy( buf , pass->pw_gecos , RANK_NAME_LENGTH ) ;
	tmp = strlen( buf ) ;
	for ( j = 0 ; j < tmp ; j ++ )
	  if ( buf[j] == ',' )
	    buf[j] = '\0' ;
      }
      XDrawString( dpy, frame, gc2, 110, 330-i + ii * 30, buf, strlen(buf) );
      
      sprintf(&buf[11],"%-8d",lank[ii].score) ;
      sprintf(&buf[7-strlen(&buf[11])],"%8d",lank[ii].score) ;
      XDrawString( dpy, frame, gc2, 290, 330-i + ii * 30,
		       buf, strlen(buf) );
      sprintf(buf,"%-2d", lank[ii].level);
      XDrawString( dpy, frame, gc2, 397, 330-i + ii * 30,
		       buf, strlen(buf) );
      XSync( dpy , 1 ) ;
    }
  
  timer( 500000 ) ;
   
  while( True )
    {
      if ( XEventsQueued( dpy, QueuedAfterFlush )){
	XNextEvent( dpy, &eve );
	if ( eve.type == KeyPress || eve.type == ButtonPress ){
	  XClearWindow( dpy , frame );
	  return ;
	}
      }
    }
}
